VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   Caption         =   "Form1"
   ClientHeight    =   1140
   ClientLeft      =   1815
   ClientTop       =   870
   ClientWidth     =   3495
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   1140
   ScaleWidth      =   3495
   Begin VB.CommandButton cmdPrint 
      Caption         =   "Print"
      Height          =   495
      Left            =   1920
      TabIndex        =   1
      Top             =   360
      Width           =   1215
   End
   Begin VB.CommandButton cmdPreview 
      Caption         =   "Preview"
      Height          =   495
      Left            =   360
      TabIndex        =   0
      Top             =   360
      Width           =   1215
   End
   Begin VB.PictureBox picHidden 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      Height          =   495
      Left            =   120
      ScaleHeight     =   495
      ScaleWidth      =   495
      TabIndex        =   2
      Top             =   120
      Visible         =   0   'False
      Width           =   495
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function CreateFont Lib "gdi32" Alias "CreateFontA" (ByVal H As Long, ByVal W As Long, ByVal E As Long, ByVal O As Long, ByVal W As Long, ByVal i As Long, ByVal U As Long, ByVal S As Long, ByVal C As Long, ByVal OP As Long, ByVal CP As Long, ByVal Q As Long, ByVal PAF As Long, ByVal F As String) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

' Font weight constants.
Private Const FW_DONTCARE = 0
Private Const FW_NORMAL = 400
Private Const FW_BOLD = 700

' Character set constants.
Private Const DEFAULT_CHARSET = 1

' Output precision constants.
Private Const OUT_TT_ONLY_PRECIS = 7

' Clipping precision constants.
Private Const CLIP_DEFAULT_PRECIS = 0
Private Const CLIP_LH_ANGLES = &H10

' Character quality constants.
Private Const PROOF_QUALITY = 2

' Pitch and family constants.
Private Const TRUETYPE_FONTTYPE = &H4
' Draw some text on the object.
Private Sub DrawText(obj As Object)
Const THE_TEXT = "Rotated text"
Const FONT_SIZE = 20
Const PRINTER_SCALE = 4
Dim wid As Single
Dim angle As Long
Dim new_font As Long
Dim old_font As Long

    ' Create a font rotated 360 degrees.
    new_font = CreateFont( _
        FONT_SIZE * PRINTER_SCALE, 0, 3600, 0, _
        FW_NORMAL, 0, 0, 0, DEFAULT_CHARSET, _
        OUT_TT_ONLY_PRECIS, _
        CLIP_LH_ANGLES Or CLIP_DEFAULT_PRECIS, _
        PROOF_QUALITY, TRUETYPE_FONTTYPE, _
        "Times New Roman")

    ' See how big the text is.
    old_font = SelectObject(picHidden.hdc, new_font)
    wid = 2 * (picHidden.TextWidth(THE_TEXT) + 120)
    picHidden.Width = wid
    picHidden.Height = wid
    picHidden.AutoRedraw = True
    picHidden.Cls

    ' Destroy the new font.
    SelectObject picHidden.hdc, old_font
    DeleteObject new_font

    ' Draw the rotated text.
    For angle = 300 To 3600 Step 300
        ' Create the rotated font.
        new_font = CreateFont( _
            FONT_SIZE * PRINTER_SCALE, 0, angle, 0, _
            FW_NORMAL, 0, 0, 0, DEFAULT_CHARSET, _
            OUT_TT_ONLY_PRECIS, _
            CLIP_LH_ANGLES Or CLIP_DEFAULT_PRECIS, _
            PROOF_QUALITY, TRUETYPE_FONTTYPE, _
            "Times New Roman")
        SelectObject picHidden.hdc, new_font

        ' Print the text.
        picHidden.CurrentX = wid / 2
        picHidden.CurrentY = wid / 2
        picHidden.Print THE_TEXT

        ' Destroy the new font.
        SelectObject picHidden.hdc, old_font
        DeleteObject new_font
    Next angle

    ' Make picHidden's image permanent.
    picHidden.Picture = picHidden.Image

    ' Copy the result onto the object.
    obj.PaintPicture picHidden.Picture, _
        0, 0, wid / PRINTER_SCALE, wid / PRINTER_SCALE, _
        0, 0, wid, wid
End Sub
' Draw the text on the preview form.
Private Sub cmdPreview_Click()
    Screen.MousePointer = vbHourglass
    DrawText Form2
    Screen.MousePointer = vbDefault

    Form2.Show vbModal
End Sub

' Draw the text on the Printer object.
Private Sub cmdPrint_Click()
    Screen.MousePointer = vbHourglass
    DrawText Printer
    Screen.MousePointer = vbDefault

    Printer.EndDoc
End Sub


